module Eco
  module API
    module Common
      module Loaders
        class Policy < Eco::API::Common::Loaders::CaseBase

          def initialize(policies)
            raise "Expected Eco::API::Policies. Given #{policies.class}" unless policies.is_a?(Eco::API::Policies)
            policies.define(self.name, &self.method(:main))
          end

          # @param people [Eco::API::Organization::People] the people in the queue of the current `job`
          # @param session [Eco::API::Session] the current session where the usecase kicks in.
          # @param options [Hash] the options that modify the case behaviour or bring some dependencies.
          # @param policy [Eco::API::Policies::Policy] the `policy` instance object.
          # @param job [Eco::API::Session::Batch::Job] the `Batch::Job` that these `people` belong to the queue thereof.
          def main(people, session, options, policy, job)
            raise "You should implement this method"
          end

        end
      end
    end
  end
end
