class Eco::API::Common::People::DefaultParsers::BooleanParser < Eco::API::Common::Loaders::Parser
  attribute :boolean

  def parser(value, deps)
    value.is_a?(Array) ? value.map { |v| truthy(v) } : truthy(value)
  end

  def serializer(value, deps)
    value.to_s
  end

  private

  def truthy (value)
    %w[true y yes x].include?(value.to_s.strip.downcase)
  end

end
