class Eco::API::Common::People::DefaultParsers::MultiParser < Eco::API::Common::Loaders::Parser
  attribute :multiple

  def parser(value, deps)
    into_a(value)
  end

  def serializer(value, deps)
    into_a(value).join("|")
  end

  private

  def into_a(value)
    return []               if value.nil?
    return value            if value.is_a?(Array)
    return value.split("|") if value.is_a?(String) && value.include?("|")
    [].push(value)
  end

end
