# Helper class to create a custom `ErrorHandler`
# @example Example of usage:
#  class Custom::ErrorHandler::EmailTaken < Eco::API::Custom::ErrorHandler
#    error Eco::API::Error::EmailTaken
#
#    def main(people, session, options, handler, job)
#      people.each do |person|
#        prev_email = person.initial_doc["email"]
#        if person.email != prev_email
#          person.email = prev_email
#        else
#          person.account = nil
#        end
#        job.add(person)
#      end
#    end
#  end
#
class Eco::API::Custom::ErrorHandler < Eco::API::Common::Loaders::ErrorHandler
end
