# Helper class to create a custom `Policy`
# @example Example of usage:
#  class Custom::Policy::StartersNLeavers < Eco::API::Custom::Policy
#    name "starters'n'leavers"
#
#    INACTIVE = "Non active"
#
#    def main(people, session, options, policy, job)
#      people.each do |person|
#        next unless details = person.details
#        # starters
#        if person.new?
#          details["status"]       = "Active"
#          details["hris-managed"] = true unless options.dig(:include, :excluded)
#        end
#
#        # leavers: native job queue to remove account
#        if job.name == "leavers"
#          details["status"]    = INACTIVE
#          person.external_id   = person.name
#          details["staff-id"]  = person.name
#        end
#      end
#    end
#
#  end
class Eco::API::Custom::Policy < Eco::API::Common::Loaders::Policy
end
