# Helper class to create a custom `UseCase`
# @example Example of usage:
#  class Custom::UseCase::Sync < Eco::API::Custom::UseCase
#    name "custom-case"
#    type :sync
#
#    def main(entries, people, session, options, usecase)
#      update   = session.new_job("main", "update", :update, usecase)
#      session.micro.with_each(entries, people, options) do |entry, person|
#        # update some data in person using data from entry
#      end
#    end
#
#  end
class Eco::API::Custom::UseCase < Eco::API::Common::Loaders::UseCase
end
