module Eco
  module API
    class MicroCases
      # @param person [Ecoportal::API::V1::Person] the person we want to update, carrying the changes to be done.
      # @param options [Hash] the options.
      # @return [Array<String>] the account parameters that should not be included.
      def account_excluded(person, options)
        [].tap do |account_excluded|
          unless person.new?
            if options.dig(:exclude, :policy_groups)
              account_excluded.push("policy_group_ids")
            end
            if options.dig(:exclude, :default_tag)
              account_excluded.push("default_tag")
            end
            if options.dig(:exclude, :login_providers)
              account_excluded.push("login_provider_ids")
            end
          end
        end
      end
    end
  end
end
