module Eco
  module API
    class MicroCases
      # Helper to preserve the original `default_tag`.
      # @note
      #   1. It only works if the original value of `default_tag` was **not** empty
      # @param person [Ecoportal::API::V1::Person] the person we want to update, carrying the changes to be done.
      # @param options [Hash] the options.
      # @return [String] the final value of `default_tag`.
      def preserve_default_tag(person, options)
        if account = person.account
          if account.as_update.key?("default_tag")
            if original = person.original_doc.dig("account", "default_tag")
              person.account.default_tag = original
            end
          end
        end
        person.account&.default_tag
      end

    end
  end
end
