module Eco
  module API
    class MicroCases
      # Sets all the core details, but the supervisor.
      # @note `supervisor_id` requires a special treatment, and therefore is always excluded.
      # @param entry [PersonEntry] the input entry with the data we should set on person.
      # @param person [Ecoportal::API::V1::Person] the person we want to update, carrying the changes to be done.
      # @param options [Hash] the options
      def set_core(entry, person, options)
        unless options.dig(:exclude, :core) && !person.new?
          entry.set_core(person, exclude: micro.core_excluded(person, options))
          micro.fix_filter_tags(person, options)
        end
      end

    end
  end
end
