module Eco
  module API
    class Session
      class Config
        class Files < BaseConfig

          def initialize(config:)
            super(config: config)
            @validations = {}
          end

          def working_directory=(path)
            self["dir"] = path
          end

          def working_directory
            if config.apis.active_api&.one_off?
              one_off_dir = File.join("one_off", config.apis.active_name.to_s)
              unless full_path = Eco::Data::Files::Directory.new(one_off_dir).create
                raise "Could not create the folder '#{full_path}'"
              end
              self["dir"] = one_off_dir
            end
            self["dir"]
          end

          def timestamp_pattern=(pattern)
            self["timestamp_pattern"] = pattern
          end

          def timestamp_pattern
            self["timestamp_pattern"]
          end

          def add_validation(format)
            raise "Block must be given" unless block_given?
            @validations[format] = Proc.new
          end

          def validate(format, input)
            @validations[format].call(input) if  @validations.key?(format)
          end
        end
      end
    end
  end
end
