module Eco
  module API
    class Session
      class Config
        class Mailer < BaseConfig

          def configured?
            required = access_key_id && secret_access_key && region
            !!required
          end

          def to=(value)
            self["to"] = value
          end

          def to
            self["to"]
          end

          def from=(value)
            self["from"] = value
          end

          def from
            self["from"]
          end

          def access_key_id=(key)
            self["access_key_id"] = key
          end

          def access_key_id
            self["access_key_id"]
          end

          def secret_access_key=(key)
            self["secret_access_key"] = key
          end

          def secret_access_key
            self["secret_access_key"]
          end

          # AWS::SES::Client
          def region=(region)
            self["region"] = region
          end

          def region
            self["region"]
          end

          # AWS::SES::Base
          def server=(domain)
            self["server"] = domain
          end

          def server
            self["server"]
          end

          # AWS::SES::Base
          def message_id_domain=(domain)
            self["message_id_domain"] = domain
          end

          def message_id_domain
            self["message_id_domain"]
          end

        end
      end
    end
  end
end
