module Eco
  module API
    class Session
      class Config
        class S3Storage < BaseConfig

          def configured?
            required = bucket_name && prefix && access_key_id && secret_access_key && region
            !!required
          end

          def bucket_name=(value)
            self["bucket_name"] = value
          end

          def bucket_name
            self["bucket_name"]
          end

          def prefix=(value)
            self["prefix"] = value
          end

          def prefix
            self["prefix"]
          end

          def access_key_id=(key)
            self["access_key_id"] = key
          end

          def access_key_id
            self["access_key_id"]
          end

          def secret_access_key=(key)
            self["secret_access_key"] = key
          end

          def secret_access_key
            self["secret_access_key"]
          end

          def region=(region)
            self["region"] = region
          end

          def region
            self["region"]
          end

          def target_files=(value)
            self["target_files"]       = [value].flatten
          end

          def target_files
            self["target_files"]
          end

          def target_directories=(value)
            self["target_directories"] = [value].flatten
          end

          def target_directories
            self["target_directories"]
          end

          def target_file_patterns=(value)
            self["target_file_patterns"] = [value].flatten
          end

          def target_file_patterns
            self["target_file_patterns"]
          end

        end
      end
    end
  end
end
