module Eco
  module API
    class Session
      class Config
        class SFTP < BaseConfig

          def configured?
            required = host && user && key_file
            !!required
          end

          def host=(value)
            self["host"] = value
          end

          def host
            self["host"]
          end

          def user=(value)
            self["user"] = value
          end

          def user
            self["user"]
          end

          def key_file=(key)
            self["key_file"] = key
          end

          def key_file
            self["key_file"]
          end

          def base_path=(path)
            self["base_path"] = path
          end

          def base_path
            self["base_path"]
          end

          def enviro_subpaths=(hash)
            self["enviro_subpaths"] = hash
          end

          def enviro_subpaths
            self["enviro_subpaths"]
          end

          def enviro_subpath
            enviro_subpaths[config.active_enviro]
          end

          def remote_folder
            base_path + "/" + enviro_subpath
          end

        end
      end
    end
  end
end
