class Eco::API::UseCases::DefaultCases::AppendUsergroupsCase < Eco::API::Common::Loaders::UseCase
  name "append-usergroups"
  type :sync

  def main(entries, people, session, options, usecase)
    micro    = session.micro
    update   = session.new_job("main", "update", :update, usecase)

    micro.with_each_present(entries, people, options, log_starter: true) do |entry, person|
      update.add(person)
      micro.append_usergroups(entry, person, options)
    end
  end

end
