class Eco::API::UseCases::DefaultCases::CreateDetailsCase < Eco::API::Common::Loaders::UseCase
  name "create-details"
  type :sync

  attr_reader :options

  def main(entries, people, session, options, usecase)
    @options = options
    micro    = session.micro
    creation = session.new_job("main", "create",  :create, usecase)

    micro.with_each_starter(entries, people, options, log_present: true, append_created: append_created) do |entry, person|
      creation.add(person)
      micro.set_core(entry, person, options)
      entry.set_details(person) unless options.dig(:exclude, :details)
    end
  end

  private

  def append_created
    options.dig(:people, :append_created)
  end

end
