class Eco::API::UseCases::DefaultCases::NewIdCase < Eco::API::Common::Loaders::UseCase
  name "new-id"
  type :sync

  def main(entries, people, session, options, usecase)
    micro    = session.micro
    update   = session.new_job("main", "update", :update, usecase, :core)
    micro.with_each_present(entries, people, options, log_starter: true) do |entry, person|
      update.add(person)
      person.external_id = entry.external_id
    end
  end

end
