class Eco::API::UseCases::DefaultCases::ResetLandingPageCase < Eco::API::Common::Loaders::UseCase
  name "reset-landing-page"
  type :transform

  attr_reader :session, :options

  def main(people, session, options, usecase)
    @session = session; @options = options
    update   = session.new_job("main", "update", :update, usecase, :core)

    people.users.each do |user|
      user.account.landing_page_id = page_id
      update.add(user)
    end
  end

  private

  def page_id
    options[:page_id]
  end


end
