class Eco::API::UseCases::DefaultCases::UpdateDetailsCase < Eco::API::Common::Loaders::UseCase
  name "update-details"
  type :sync

  def main(entries, people, session, options, usecase)
    micro    = session.micro
    update   = session.new_job("main", "update", :update, usecase)
    supers   = session.new_job("post", "supers", :update, usecase, :core)

    micro.with_each_present(entries, people, options, log_starter: true) do |entry, person|
      update.add(person)
      micro.set_core_with_supervisor(entry, person, people, supers, options)
      entry.set_details(person) unless options.dig(:exclude, :details)
    end
  end

end
