require_relative 'scripting/args_helpers'
require_relative 'scripting/argument'
require_relative 'scripting/arguments'

module Eco
  class CLI
    class Scripting
      include Scripting::ArgsHelpers

      def initialize(argv = ARGV)
        @argv = argv
      end

      def argv
        @argv.dup
      end

      def args_contain?(*values)
        match?(argv, patterns, [:any, :or, :insensitive, :pattern])
      end

      def modifiers(*values)
        values.select { |arg| is_modifier?(arg) }
      end

    end
  end
end


SCR = Eco::CLI::Scripting.new(ARGV)
