module Eco
  module Data
    module Files
      class FilePattern
        def initialize(file = "")
          @source_file = file
        end

        def resolve(dir: nil, start: "")
          pattern(dir).gsub('*', start)
        end

        def match?(file, dir: nil)
          /#{Regexp.escape(self.pattern(dir))}/i.match?(file)
        end

        def any?(files, dir: nil)
          return false unless files.is_a?(Array)
          files.any? { |file|  match?(file, dir: dir) }
        end

        def pattern(dir = nil)
          return File.join(dir, "*") if @source_file.to_s.empty?
          filename = File.basename(@source_file)
          path = File.dirname(@source_file)
          path = File.join(dir, path) if dir
          wildcard = (filename =~ /\*/)? "" : "*"
          File.join(path, wildcard + filename)
        end
      end
    end
  end
end
